Coin: SoSeparator Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoSeparator Class Reference
Node Classes

The SoSeparator class is a state-preserving group node. More...

`#include <Inventor/nodes/SoSeparator.h>`

Inheritance diagram for SoSeparator:

## Public Types
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoSeparator (void)
| SoSeparator (const int nchildren)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | notify (SoNotList *nl)
virtual SbBool | affectsState (void) const
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | addChild (SoNode *node)
virtual void | insertChild (SoNode *child, int newchildindex)
virtual SoNode * | getChild (int index) const
virtual int | findChild (const SoNode *node) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int childindex)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int index, SoNode *newchild)
virtual void | replaceChild (SoNode *oldchild, SoNode *newchild)
virtual void | pick (SoPickAction *action)
virtual void | write (SoWriteAction *action)
virtual SoChildList * | getChildren (void) const
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setNumRenderCaches (const int howmany)
static int | getNumRenderCaches (void)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoSeparator ()
virtual SbBool | cullTest (SoState *state)
virtual SbBool | cullTest (SoGLRenderAction *action, int &cullresults)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoNotRec | createNotRec (void)
void | setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoGroup
SoChildList * | children
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoSeparator class is a state-preserving group node.

Subgraphs parented by SoSeparator nodes will not affect the state, as they push and pop the traversal state before and after traversal of its children.

SoSeparator nodes also provides options for traversal optimization through the use of caching.

FILE FORMAT/DEFAULTS:

Separator {
renderCaching AUTO
boundingBoxCaching AUTO
renderCulling AUTO
pickCulling AUTO
}
SoSeparator::boundingBoxCaching
SoSFEnum boundingBoxCaching
Definition SoSeparator.h:59
SoSeparator::AUTO
@ AUTO
Definition SoSeparator.h:55
SoSeparator::renderCaching
SoSFEnum renderCaching
Definition SoSeparator.h:58
SoSeparator::renderCulling
SoSFEnum renderCulling
Definition SoSeparator.h:60
SoSeparator::pickCulling
SoSFEnum pickCulling
Definition SoSeparator.h:61

See also
  SoTransformSeparator

## Member Enumeration Documentation

## ◆ CacheEnabled

enum SoSeparator::CacheEnabled

Enumeration of flags for the fields deciding which optimizations to do in SoSeparator nodes. There are two types of settings available: caching policies or culling policies. See documentation of fields.

Enumerator
OFF | No caching.
ON | Always try to cache state.
AUTO | Use heuristics to try to figure out the optimal caching policy.

## Constructor & Destructor Documentation

## ◆ SoSeparator() [1/2]

SoSeparator::SoSeparator | ( | void |  | ) |

Default constructor.

## ◆ SoSeparator() [2/2]

SoSeparator::SoSeparator | ( | const int | nchildren | ) |

Constructor.

The argument should be the approximate number of children which is expected to be inserted below this node. The number need not be exact, as it is only used as a hint for better memory resource allocation.

## ◆ ~SoSeparator()

SoSeparator::~SoSeparator | ( |  | ) |
| protectedvirtual

Destructor. Frees resources used to implement caches.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoSeparator::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoSeparator::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoGroup.

Reimplemented in SoAnnotation, SoExtSelection, SoGeoSeparator, SoLocateHighlight, SoSelection, SoShadowGroup, and SoWWWAnchor.

## ◆ getFieldDataPtr()

const SoFieldData ** SoSeparator::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoSeparator::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoGroup.

Reimplemented in SoAnnotation, SoExtSelection, SoGeoSeparator, SoLocateHighlight, SoSelection, SoShadowGroup, and SoWWWAnchor.

## ◆ doAction()

void SoSeparator::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoGroup.

## ◆ GLRender()

void SoSeparator::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoGroup.

Reimplemented in SoAnnotation.

## ◆ GLRenderBelowPath()

void SoSeparator::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) |
| virtual

SGI Open Inventor v2.1 obsoleted support for SoGLRenderAction::addMethod(). Instead, GLRender() might be called directly, and to optimize traversal, the SoSeparator node calls GLRenderBelowPath whenever the path code is BELOW_PATH or NO_PATH (path code is guaranteed not to change). To be compatible with SGI's Inventor (and thereby also TGS') we have chosen to follow their implementation in this respect.

SoSeparator::GLRenderBelowPath() does not traverse its children using SoChildList::traverse(), but calls GLRenderBelowPath() directly for all its children.

Reimplemented from SoNode.

Reimplemented in SoAnnotation, SoExtSelection, SoGeoSeparator, SoLocateHighlight, and SoShadowGroup.

## ◆ GLRenderInPath()

void SoSeparator::GLRenderInPath | ( | SoGLRenderAction * | action | ) |
| virtual

Implements the SoAction::IN_PATH traversal method for the rendering action.

Reimplemented from SoNode.

Reimplemented in SoAnnotation, SoGeoSeparator, SoLocateHighlight, and SoShadowGroup.

## ◆ GLRenderOffPath()

void SoSeparator::GLRenderOffPath | ( | SoGLRenderAction * | action | ) |
| virtual

Implements the SoAction::OFF_PATH traversal method for the rendering action.

Reimplemented from SoNode.

Reimplemented in SoAnnotation.

## ◆ callback()

void SoSeparator::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoGroup.

Reimplemented in SoGeoSeparator.

## ◆ getBoundingBox()

void SoSeparator::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoGroup.

Reimplemented in SoGeoSeparator.

## ◆ getMatrix()

void SoSeparator::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoGroup.

Reimplemented in SoGeoSeparator.

## ◆ handleEvent()

void SoSeparator::handleEvent | ( | SoHandleEventAction * | action | ) |
| virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoGroup.

Reimplemented in SoExtSelection, SoLocateHighlight, SoSelection, and SoWWWAnchor.

## ◆ rayPick()

void SoSeparator::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

Reimplemented in SoGeoSeparator.

## ◆ search()

void SoSeparator::search | ( | SoSearchAction * | action | ) |
| virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
  SoSearchAction

Reimplemented from SoGroup.

## ◆ getPrimitiveCount()

void SoSeparator::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoGroup.

Reimplemented in SoGeoSeparator.

## ◆ audioRender()

void SoSeparator::audioRender | ( | SoAudioRenderAction * | action | ) |
| virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoGroup.

## ◆ notify()

void SoSeparator::notify | ( | SoNotList * | l | ) |
| virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Reimplemented in SoShadowGroup.

## ◆ setNumRenderCaches()

void SoSeparator::setNumRenderCaches | ( | const int | howmany | ) |
| static

Set the maximum number of caches that SoSeparator nodes may allocate for render caching.

This is a global value which will be used for all SoSeparator nodes, but the value indicate the maximum number per SoSeparator node.

More caches might give better performance, but will use more memory. The built-in default value is 2.

The value can also be changed globally by setting the host system's environment variable IV_SEPARATOR_MAX_CACHES to the wanted number. This is primarily meant as an aid during debugging, to make it easy to turn off render caching completely (by setting "IV_SEPARATOR_MAX_CACHES=0") without having to change any application code.

## ◆ getNumRenderCaches()

int SoSeparator::getNumRenderCaches | ( | void |  | ) |
| static

Returns maximum number of caches SoSeparator nodes are allowed to use for render caching.

See also
  setNumRenderCaches()

## ◆ affectsState()

SbBool SoSeparator::affectsState | ( | void |  | ) | const
| virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

## ◆ cullTest() [1/2]

SbBool SoSeparator::cullTest | ( | SoState * | state | ) |
| protectedvirtual

Internal method which do view frustum culling. For now, view frustum culling is performed if the renderCulling field is `AUTO` or `ON`, and the bounding box cache is valid.

Returns `TRUE` if this separator is outside view frustum, `FALSE` if inside.

## ◆ cullTest() [2/2]

SbBool SoSeparator::cullTest | ( | SoGLRenderAction * | action,
|  | int & | cullresults )
| protectedvirtual

This is an internal Open Inventor method. We've implemented view frustum culling in a different manner. Let us know if you need this function, and we'll consider implementing it.

## ◆ readInstance()

SbBool SoSeparator::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoGroup.

## Member Data Documentation

## ◆ renderCaching

SoSFEnum SoSeparator::renderCaching

Policy for caching of rendering instructions for faster execution. This will typically use the OpenGL displaylist mechanism.

Default value is SoSeparator::AUTO.

If you know that some parts of your scene will never change, rendering might happen faster if you explicitly set this field to SoSeparator::ON. If you on the other hand know that parts of the scene will change a lot (like for every redraw), it will be beneficial to set this field to SoSeparator::OFF for the top-level separator node of this (sub)graph.

Usually the default setting of `AUTO` will handle any scene very well. The advantages that can be had from setting SoSeparator::renderCaching to `ON` are:

- If you positively know that the geometry under the SoSeparator is static, you get the cache set up right away.

  Otherwise, the code in Coin will do a bit of testing and decide by some heuristics whether or not to enable it. That will make the rendering be a tiny bit slower right after startup than with renderCaching set to `ON`.

  (The slow-down should hardly be noticeable, though, so we don't advice application programmers to do this.)

- For many of the shape nodes that can contain many basic primitives, like e.g. SoFaceSet, SoIndexedFaceSet, SoLineSet, etc etc, there is an internal threshold for how many primitives a node can contain before we don't do caching when SoSeparator::renderCaching is set to `AUTO`.

  The reason we do this is because OpenGL render lists can potentially suck up a lot of memory resources on the graphics card.

  But if you know that it will be advantageous on your particular platform, you can override this by setting SoSeparator::renderCaching equal to `ON`.

  (We don't advice application programmers to do this either. A better solution in these cases would simply be to get in touch with SIM and describe the platform and the problem, and we could integrate a proper fix into Coin.)

There are good reasons for setting renderCaching to `OFF`, like when you know the geometry will be changing a lot. Still, Coin should work fairly well even without this optimization. (If renderCaching is `AUTO` over a subgraph with changing geometry or other cache smashing nodes, the caching heuristics will stop the SoSeparator node from trying to make caches – at least after a few tries have been made and failed.)

The short story about how auto-caching works is as follows:

- For vertex-based shapes with fewer than 100 triangles and where the geometry is detected to be fairly static, caching is enabled.

- For shapes with more than 1000 triangles, it is disabled, to avoid spending too much of the on-board graphics card's memory resources.

- For shapes with more than 100 but less than 1000 triangles, display list caching will be turned on if our heuristics decides that the geometry can be considered static.

The maximum threshold (of 1000) is higher when doing remote rendering (as when rendering from one X11-based system to another).

Disabling the display list caching takes precedence over enabling, so if you have a SoSeparator containing a shape with more than 1000 triangles and a shape with fewer than 100 triangles, caching will be disabled for the SoSeparator.

It's possible to tune the limits using some environment variables:

- `COIN_AUTOCACHE_LOCAL_MIN` can be used to change the enable-caching limit, while `COIN_AUTOCACHE_LOCAL_MAX` controls the disable-caching limit.

- The corresponding variables for remote rendering are `COIN_AUTOCACHE_REMOTE_MIN` and `COIN_AUTOCACHE_REMOTE_MAX`.

## ◆ boundingBoxCaching

SoSFEnum SoSeparator::boundingBoxCaching

Policy for caching bounding box calculations. Default value is SoSeparator::AUTO.

See also documentation for SoSeparator::renderCaching.

## ◆ renderCulling

SoSFEnum SoSeparator::renderCulling

Policy for doing viewport culling during rendering traversals. Default value is SoSeparator::AUTO.

When the render culling is turned off for Coin, it will be left to be done for the underlying immediate mode rendering library. This will often be faster than doing culling from within Coin, so be careful to monitor the change in execution speed if setting this field to SoSeparator::ON.

See also documentation for SoSeparator::renderCaching.

## ◆ pickCulling

SoSFEnum SoSeparator::pickCulling

Policy for doing viewport culling during pick traversals. Default value is SoSeparator::AUTO.

See documentation for SoSeparator::renderCulling.

The documentation for this class was generated from the following files:

- SoSeparator.h
- SoSeparator.cpp